//+------------------------------------------------------------------+
//|                             #(T_S_R)-Daily Range Calculator .mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#property link      "Data window by cja"
//+------------------------------------------------------------------+
//|                                                   TSR_Ranges.mq4 |
//|                                         Copyright  2006, Ogeima |
//|                                             ph_bresson@yahoo.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Ogeima"
#property link      "ph_bresson@yahoo.com"

#property indicator_separate_window
//---- input parameters

extern color colorText = Black ;
extern color colorPrice = MidnightBlue ;

extern double  Risk_to_Reward_ratio =  3.0;
int nDigits;

int    digits, period  ; 
string symbol, tChartPeriod ;  
double point;

//+------------------------------------------------------------------+
int init()
{
   period       =  Period() ;     
   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ;

IndicatorShortName("TSR");
   if(Symbol()=="GBPJPY" || Symbol()=="EURJPY" || Symbol()=="USDJPY" || Symbol()=="GOLD" || Symbol()=="USDMXN") nDigits = 2;
   if(Symbol()=="GBPUSD" || Symbol()=="EURUSD" || Symbol()=="NZDUSD" || Symbol()=="USDCHF"  ||
   Symbol()=="USDCAD" || Symbol()=="AUDUSD" || Symbol()=="EURUSD" || Symbol()=="EURCHF"  || Symbol()=="EURGBP"
   || Symbol()=="EURCAD" || Symbol()=="EURAUD" || Symbol()=="AUDNZD")nDigits = 4;

   return(0);
}
//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
    
//+------------------------------------------------------------------+
int deinit()
  {
     
   ObDeleteObjectsByPrefix("TSR");  
   TRO() ;
   return(0);
  }
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   //----
   int R1=0,R5=0,R10=0,R20=0,RAvg=0;
   int RoomUp=0,RoomDown=0,StopLoss_Long=0,StopLoss_Short=0;
    int      TodayRange=0;
   double   SL_Long=0,SL_Short=0;
   double   low0=0,high0=0;
   string   Text="";
   int i=0;

   R1 =  (iHigh(NULL,PERIOD_D1,1)-iLow(NULL,PERIOD_D1,1))/Point;
   for(i=1;i<=5;i++)      R5    =    R5  +  (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/Point;
   for(i=1;i<=10;i++)      R10   =    R10 +  (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/Point;
   for(i=1;i<=20;i++)      R20   =    R20 +  (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/Point;
   TodayRange = (iHigh( NULL,PERIOD_D1,0)-iLow(NULL,PERIOD_D1,0))/Point;
   R5 = R5/5;
   R10 = R10/10;
   R20 = R20/20;
   RAvg  =  (R1+R5+R10+R20)/4;    

   low0  =  iLow(NULL,PERIOD_D1,0);
   high0 =  iHigh(NULL,PERIOD_D1,0);
   RoomUp   =  RAvg - (Bid - low0)/Point;
   RoomDown =  RAvg - (high0 - Bid)/Point;
   StopLoss_Long  =  RoomUp/Risk_to_Reward_ratio;
   SL_Long        =  Bid - StopLoss_Long*Point;
   StopLoss_Short =  RoomDown/Risk_to_Reward_ratio;
   SL_Short       =  Bid + StopLoss_Short*Point;


   Comment(Text);
  
   string P=Period();
  
  int WINDOW = WindowFind("TSR") ;
   
        ObjectCreate("TSR_", OBJ_LABEL, WINDOW, 0, 0);
        ObjectSetText("TSR_",StringSubstr(Symbol(),0),10, "Arial Bold", colorText);
        ObjectSet("TSR_", OBJPROP_CORNER, 0);
        ObjectSet("TSR_", OBJPROP_XDISTANCE, 25);
        ObjectSet("TSR_", OBJPROP_YDISTANCE, 2);
        ObjectCreate("TSR_1", OBJ_LABEL, WINDOW, 0, 0);
        ObjectSetText("TSR_1",StringSubstr(P,0),10, "Arial Bold", colorText);
        ObjectSet("TSR_1", OBJPROP_CORNER, 0);
        ObjectSet("TSR_1", OBJPROP_XDISTANCE, 90);
        ObjectSet("TSR_1", OBJPROP_YDISTANCE, 2);
        
        ObjectCreate("TSR_2", OBJ_LABEL, WINDOW, 0, 0);
        ObjectSetText("TSR_2","Avg D1 Range:", 8, "Arial Bold", colorText);
        ObjectSet("TSR_2", OBJPROP_CORNER, 0);
        ObjectSet("TSR_2", OBJPROP_XDISTANCE, 120);
        ObjectSet("TSR_2", OBJPROP_YDISTANCE, 2);
        ObjectCreate("TSR_3", OBJ_LABEL, WINDOW, 0, 0);
        ObjectSetText("TSR_3",DoubleToStr(RAvg ,0),10, "Arial Bold", Brown);
        ObjectSet("TSR_3", OBJPROP_CORNER, 0);
        ObjectSet("TSR_3", OBJPROP_XDISTANCE, 200);
        ObjectSet("TSR_3", OBJPROP_YDISTANCE, 2);
        
        ObjectCreate("TSR_120", OBJ_LABEL, WINDOW, 0, 0);
        ObjectSetText("TSR_120","TODAY:", 8, "Arial Bold", colorText);
        ObjectSet("TSR_120", OBJPROP_CORNER, 0);
        ObjectSet("TSR_120", OBJPROP_XDISTANCE, 230);
        ObjectSet("TSR_120", OBJPROP_YDISTANCE, 2);
        ObjectCreate("TSR_121", OBJ_LABEL, WINDOW, 0, 0);
        ObjectSetText("TSR_121",DoubleToStr(TodayRange ,0),10, "Arial Bold", Brown);
        ObjectSet("TSR_121", OBJPROP_CORNER, 0);
        ObjectSet("TSR_121", OBJPROP_XDISTANCE, 280);
        ObjectSet("TSR_121", OBJPROP_YDISTANCE, 2);
              
        double HIDaily = iMA(Symbol(),PERIOD_D1,1,0,MODE_HIGH,PRICE_HIGH,0);
        double LOWDaily = iMA(Symbol(),PERIOD_D1,1,0,MODE_LOW,PRICE_LOW,0); 
        double YEST_HIDaily = iMA(Symbol(),PERIOD_D1,1,0,MODE_HIGH,PRICE_HIGH,1);
        double YEST_LOWDaily = iMA(Symbol(),PERIOD_D1,1,0,MODE_LOW,PRICE_LOW,1); 
       
        ObjectCreate("TSR_high", OBJ_LABEL, WINDOW, 0, 0);
        ObjectSetText("TSR_high",DoubleToStr(HIDaily,Digits), 10, "Arial Bold", Blue);
        ObjectSet("TSR_high", OBJPROP_CORNER, 0);
        ObjectSet("TSR_high", OBJPROP_XDISTANCE, 345);
        ObjectSet("TSR_high", OBJPROP_YDISTANCE, 2);
        
        ObjectCreate("TSR_high2", OBJ_LABEL, WINDOW, 0, 0);
        ObjectSetText("TSR_high2","High:", 7, "Arial Bold", colorText);
        ObjectSet("TSR_high2", OBJPROP_CORNER, 0);
        ObjectSet("TSR_high2", OBJPROP_XDISTANCE, 310);
        ObjectSet("TSR_high2", OBJPROP_YDISTANCE, 2);
        
        ObjectCreate("TSR_low", OBJ_LABEL, WINDOW, 0, 0);
        ObjectSetText("TSR_low",DoubleToStr(LOWDaily,Digits), 10, "Arial Bold", Red);
        ObjectSet("TSR_low", OBJPROP_CORNER, 0);
        ObjectSet("TSR_low", OBJPROP_XDISTANCE, 430);
        ObjectSet("TSR_low", OBJPROP_YDISTANCE, 2);
        
        ObjectCreate("TSR_low2", OBJ_LABEL, WINDOW, 0, 0);
        ObjectSetText("TSR_low2","Low:", 7, "Arial Bold", colorText);
        ObjectSet("TSR_low2", OBJPROP_CORNER, 0);
        ObjectSet("TSR_low2", OBJPROP_XDISTANCE, 395);
        ObjectSet("TSR_low2", OBJPROP_YDISTANCE, 2);
                     
         double CURR =iMA(Symbol(),0,1,0,MODE_EMA,PRICE_CLOSE,0);
         double RANGE = (HIDaily-LOWDaily) ; 
       
        ObjectCreate("TSR_price", OBJ_LABEL, WINDOW, 0, 0);
        ObjectSetText("TSR_price","Price:", 7, "Arial Bold", colorText);
        ObjectSet("TSR_price", OBJPROP_CORNER, 0);
        ObjectSet("TSR_price", OBJPROP_XDISTANCE, 480);
        ObjectSet("TSR_price", OBJPROP_YDISTANCE, 2);
            
        ObjectCreate("TSR_price2", OBJ_LABEL, WINDOW, 0, 0);
        ObjectSetText("TSR_price2",DoubleToStr(CURR,Digits), 10, "Arial Bold", colorPrice);
        ObjectSet("TSR_price2", OBJPROP_CORNER, 0);
        ObjectSet("TSR_price2", OBJPROP_XDISTANCE, 520);
        ObjectSet("TSR_price2", OBJPROP_YDISTANCE, 2);
        
        
        
       
        int yInc = 20 ;
       
              
        double H  = iHigh(symbol,period,0);
        double L  = iLow(symbol,period,0); 
        double pH = iHigh(symbol,period,1);
        double py = iLow(symbol,period,1);         
        double RG = ( H - L ) / point ;
        
        ObjectCreate("TSR"+"TSR2", OBJ_LABEL, WINDOW, 0, 0);
        ObjectSetText("TSR"+"TSR2", tChartPeriod + " Range:", 8, "Arial Bold", colorText);
        ObjectSet("TSR"+"TSR2", OBJPROP_CORNER, 0);
        ObjectSet("TSR"+"TSR2", OBJPROP_XDISTANCE, 120);
        ObjectSet("TSR"+"TSR2", OBJPROP_YDISTANCE, yInc +  2);
        
        ObjectCreate("TSR"+"TSR3", OBJ_LABEL, WINDOW, 0, 0);
        ObjectSetText("TSR"+"TSR3",DoubleToStr(RG ,0),10, "Arial Bold", Brown);
        ObjectSet("TSR"+"TSR3", OBJPROP_CORNER, 0);
        ObjectSet("TSR"+"TSR3", OBJPROP_XDISTANCE, 200);
        ObjectSet("TSR"+"TSR3", OBJPROP_YDISTANCE, yInc +  2);
 /*       
        ObjectCreate("TSR"+"TSR120", OBJ_LABEL, WINDOW, 0, 0);
        ObjectSetText("TSR"+"TSR120","TODAY:", 8, "Arial Bold", colorText);
        ObjectSet("TSR"+"TSR120", OBJPROP_CORNER, 0);
        ObjectSet("TSR"+"TSR120", OBJPROP_XDISTANCE, 230);
        ObjectSet("TSR"+"TSR120", OBJPROP_YDISTANCE, yInc +  2);
        
        ObjectCreate("TSR"+"TSR121", OBJ_LABEL, WINDOW, 0, 0);
        ObjectSetText("TSR"+"TSR121",DoubleToStr(RG ,0),10, "Arial Bold", Brown);
        ObjectSet("TSR"+"TSR121", OBJPROP_CORNER, 0);
        ObjectSet("TSR"+"TSR121", OBJPROP_XDISTANCE, 280);
        ObjectSet("TSR"+"TSR121", OBJPROP_YDISTANCE, yInc +  2);
*/
       
        ObjectCreate("TSR"+"high", OBJ_LABEL, WINDOW, 0, 0);
        ObjectSetText("TSR"+"high",DoubleToStr(H,Digits), 10, "Arial Bold", Blue);
        ObjectSet("TSR"+"high", OBJPROP_CORNER, 0);
        ObjectSet("TSR"+"high", OBJPROP_XDISTANCE, 345);
        ObjectSet("TSR"+"high", OBJPROP_YDISTANCE, yInc +  2);
        
        ObjectCreate("TSR"+"high2", OBJ_LABEL, WINDOW, 0, 0);
        ObjectSetText("TSR"+"high2","High:", 7, "Arial Bold", colorText);
        ObjectSet("TSR"+"high2", OBJPROP_CORNER, 0);
        ObjectSet("TSR"+"high2", OBJPROP_XDISTANCE, 310);
        ObjectSet("TSR"+"high2", OBJPROP_YDISTANCE, yInc +  2);
        
        ObjectCreate("TSR"+"low", OBJ_LABEL, WINDOW, 0, 0);
        ObjectSetText("TSR"+"low",DoubleToStr(L,Digits), 10, "Arial Bold", Red);
        ObjectSet("TSR"+"low", OBJPROP_CORNER, 0);
        ObjectSet("TSR"+"low", OBJPROP_XDISTANCE, 430);
        ObjectSet("TSR"+"low", OBJPROP_YDISTANCE, yInc +  2);
        
        ObjectCreate("TSR"+"low2", OBJ_LABEL, WINDOW, 0, 0);
        ObjectSetText("TSR"+"low2","Low:", 7, "Arial Bold", colorText);
        ObjectSet("TSR"+"low2", OBJPROP_CORNER, 0);
        ObjectSet("TSR"+"low2", OBJPROP_XDISTANCE, 395);
        ObjectSet("TSR"+"low2", OBJPROP_YDISTANCE, yInc +  2);
                     
    
   return(0);

}
//+--------- TRO MODIFICATION ---------------------------------------+  

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}

   
//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}

 
//+------------------------------------------------------------------+



